//  Copyright (c) 2022 Cisco and/or its affiliates.
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at:
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

package binapigen

const (
	// generatedCodeVersion indicates a version of the generated code.
	// It is incremented whenever an incompatibility between the generated code and
	// GoVPP api package is introduced; the generated code references
	// a constant, api.GoVppAPIPackageIsVersionN (where N is generatedCodeVersion).
	generatedCodeVersion = 2

	generatedFilenameSuffix = ".ba.go"
)

// library dependencies
const (
	strconvPkg = GoImportPath("strconv")

	govppApiPkg   = GoImportPath("go.fd.io/govpp/api")
	govppCodecPkg = GoImportPath("go.fd.io/govpp/codec")
)

func genCodeGeneratedComment(g *GenFile) {
	g.P("// Code generated by GoVPP's binapi-generator. DO NOT EDIT.")
}
